package dev.shadowsoffire.apotheosis.adventure.affix.effect;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.datafixers.util.Function3;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixType;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import dev.shadowsoffire.placebo.util.StepFunction;
import java.util.Map;
import java.util.Set;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.tags.DamageTypeTags;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;

public class DamageReductionAffix extends Affix {
  public static final Codec<dev.shadowsoffire.apotheosis.adventure.affix.effect.DamageReductionAffix> CODEC;
  
  protected final DamageType type;
  
  protected final Map<LootRarity, StepFunction> values;
  
  protected final Set<LootCategory> types;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)DamageType.CODEC.fieldOf("damage_type").forGetter(()), (App)GemBonus.VALUES_CODEC.fieldOf("values").forGetter(()), (App)LootCategory.SET_CODEC.fieldOf("types").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.affix.effect.DamageReductionAffix::new));
  }
  
  public DamageReductionAffix(DamageType type, Map<LootRarity, StepFunction> levelFuncs, Set<LootCategory> types) {
    super(AffixType.ABILITY);
    this.type = type;
    this.values = levelFuncs;
    this.types = types;
  }
  
  public boolean canApplyTo(ItemStack stack, LootCategory cat, LootRarity rarity) {
    return (!cat.isNone() && (this.types.isEmpty() || this.types.contains(cat)) && this.values.containsKey(rarity));
  }
  
  public MutableComponent getDescription(ItemStack stack, LootRarity rarity, float level) {
    return Component.m_237110_("affix.apotheosis:damage_reduction.desc", new Object[] { Component.m_237115_("misc.apotheosis." + this.type.id), fmt(100.0F * getTrueLevel(rarity, level)) });
  }
  
  public Component getAugmentingText(ItemStack stack, LootRarity rarity, float level) {
    MutableComponent comp = getDescription(stack, rarity, level);
    MutableComponent mutableComponent1 = Component.m_237110_("%s%%", new Object[] { fmt(100.0F * getTrueLevel(rarity, 0.0F)) });
    MutableComponent mutableComponent2 = Component.m_237110_("%s%%", new Object[] { fmt(100.0F * getTrueLevel(rarity, 1.0F)) });
    return (Component)comp.m_7220_((Component)valueBounds((Component)mutableComponent1, (Component)mutableComponent2));
  }
  
  public float onHurt(ItemStack stack, LootRarity rarity, float level, DamageSource src, LivingEntity ent, float amount) {
    if (!src.m_269533_(DamageTypeTags.f_268738_) && !src.m_269533_(DamageTypeTags.f_268413_) && this.type.test(src))
      return amount * (1.0F - getTrueLevel(rarity, level)); 
    return super.onHurt(stack, rarity, level, src, ent, amount);
  }
  
  private float getTrueLevel(LootRarity rarity, float level) {
    return ((StepFunction)this.values.get(rarity)).get(level);
  }
  
  public Codec<? extends Affix> getCodec() {
    return (Codec)CODEC;
  }
}
